#include <IRremote.hpp>

const int RECV_PIN = 7 ;
IRrecv irrecv(RECV_PIN);
decode_results results;
int ledState = 0;
int buttonPressed = 1;
long unsigned int irRemote = 0xA32AB931;
long unsigned int irRemoteOld = 0;
long unsigned int irRemoteNew = 0;
int modeLearning = 0;
int irRemoteNewLock = 0;

void setup() {
  pinMode(12, OUTPUT);
  pinMode(10, INPUT_PULLUP);
  pinMode(9, OUTPUT);
  Serial.begin(9600);
  irrecv.enableIRIn();
  irrecv.blink13(true);

  digitalWrite(12, LOW);  
  
}

void loop() {
  if(!digitalRead(10)){ //(1)
    modeLearning = 1;
  }
  systemLearning();
  
  if(irrecv.decode(&results)){
    Serial.println(results.value, HEX);
    if(results.value == irRemote){
       if(ledState == 0){
         digitalWrite(12, LOW);
         ledState = 1;
       }else{
         digitalWrite(12, HIGH);
         ledState = 0;
       }
       delay(500);// FOR DEBOUNCE BUTTON
    }
    irrecv.resume();
  }
  
}

void systemLearning(){//(2)
  Serial.println("You Have entered learning mode :");
  int counterNumberTruePress = 0;//(5)
  irRemoteNewLock = 0;
  while(modeLearning == 1){//(3)
      if(irrecv.decode(&results)){//(4)
        irRemoteOld = results.value;
        Serial.println(irRemoteOld, HEX);
          if(!irRemoteNewLock){  
            irRemoteNew = irRemoteOld;
            irRemoteNewLock = 1;
          }
          if(irRemoteOld == irRemoteNew){//(6)
            digitalWrite(9, HIGH);
            delay(100);
            digitalWrite(9, LOW);
            counterNumberTruePress++;
          }else{
            digitalWrite(12, HIGH);
            delay(500);
            digitalWrite(12, LOW);
            modeLearning = 0;
          }
          irrecv.resume();        
      }
      if(counterNumberTruePress == 5){//7
        digitalWrite(9, HIGH);
        delay(1000);
        digitalWrite(9, LOW);
        modeLearning = 0;
        irRemote = irRemoteNew;
        Serial.println("button change complate successfully . end of learning mode");
      }
  }
}
